/* -------------------------- */
/* -------------------------- */
/*  Some global tag defines - */
/* -------------------------- */
/* -------------------------- */

#define TVT_Data		(0x80001000)	/* Just a tag offset like TAG_USER */
#define TVT_Memory		(0xC0001000)	/* Just a tag offset like TAG_USER */

#define TV_VendorID		(0x90001018)
#define TV_DeviceID		(0x90001019)
#define TV_SubSystemID		(0x9000101A)
#define TV_SubSystemVendorID	(0x9000101B)
#define TV_RevisionID		(0x9000101C)
#define TV_ClassRevision	(0x9000101D)
#define TV_InternalID		(0x9000101E)
#define TV_PCIHandle		(0x9000101F)
#define TV_BaseMemory		(0x90001020)
#define TV_IRQNumber		(0x90001021)
#define TV_Priority		(0x90001022)
#define TV_Number		(0x90001023)
#define TV_Task			(0x90001024)
#define TV_TaskSignalMask	(0x90001025)
#define TV_UpdateCard		(0x90001026)

#define TV_CardName		(0xD0001019)
#define TV_VendorName		(0xD000101A)
#define TV_SubSystemVendorName	(0xD000101B)


/* --------------------------------- */
/* --------------------------------- */
/*  Data type hardware setup tags! - */
/* --------------------------------- */
/* --------------------------------- */

/* ----------------------- */
/*  Driver Specific Tags - */
/* ----------------------- */

/* TV_                      = TVT_Data+000 */
#define TV_DriverSetup		(TVT_Data+197)
#define TV_DriverSupport	(TVT_Data+198)
#define TV_DriverStatus		(TVT_Data+199)

/* ---------------------- */
/*  Audio Specific Tags - */
/* ---------------------- */

#define TV_AudioInputType	(TVT_Data+200)
#define TV_AudioInputMode	(TVT_Data+201)
#define TV_AudioInputNorm	(TVT_Data+202)

#define TV_AudioSetup		(TVT_Data+397)
#define TV_AudioSupport		(TVT_Data+398)
#define TV_AudioStatus		(TVT_Data+399)

/* ---------------------- */
/*  Video Specific Tags - */
/* ---------------------- */

#define TV_VideoInputType	(TVT_Data+400)
#define TV_VideoTargetWidth	(TVT_Data+401)
#define TV_VideoTargetHeight	(TVT_Data+402)
#define TV_VideoTargetArray	(TVT_Data+403)
#define TV_VideoTargetReserved	(TVT_Data+404)
#define TV_VideoTargetBytesPerRow	(TVT_Data+405)
#define TV_VideoTargetRGBFormat	(TVT_Data+406)
#define TV_VideoWidthMax	(TVT_Data+407)	/* Maximal width of the current signal (may be scaled) */
#define TV_VideoHeightMax	(TVT_Data+408)	/* Maximal height of the current signal (may be scaled) */
#define TV_VideoWidthMin	(TVT_Data+409)	/* Minimal width of the current signal (may be scaled) */
#define TV_VideoHeightMin	(TVT_Data+410)	/* Minimal height of the current signal (may be scaled) */
#define TV_VideoWidthFull	(TVT_Data+411)	/* Full width of the current signal (no interpolation/no scaling) */
#define TV_VideoHeightFull	(TVT_Data+412)	/* Full height of the current signal (no interpolation/no scaling) */
#define TV_VideoWidthLimit	(TVT_Data+413)	/* Maximal possible width */
#define TV_VideoHeightLimit	(TVT_Data+414)	/* Maximal possible height */

#define TV_VideoBrightness	(TVT_Data+415)	/* LONG (not ULONG !!!) */
#define TV_VideoContrast	(TVT_Data+416)	/* LONG (not ULONG !!!) */
#define TV_VideoColor		(TVT_Data+417)	/* LONG (not ULONG !!!) */

#define TV_VideoInputNorm	(TVT_Data+418)

#define TV_VideoSetup		(TVT_Data+597)
#define TV_VideoSupport		(TVT_Data+598)
#define TV_VideoStatus		(TVT_Data+599)

/* ------------------------ */
/*  AVTuner Specific Tags - */
/* ------------------------ */

#define TV_AVTunerFrequency	(TVT_Data+600)
#define TV_AVTunerFrequencyMin	(TVT_Data+601)
#define TV_AVTunerFrequencyMax	(TVT_Data+602)
#define TV_AVTunerMode		(TVT_Data+603)
#define TV_AVTunerScan		(TVT_Data+604)

#define TV_AVTunerSetup		(TVT_Data+797)
#define TV_AVTunerSupport	(TVT_Data+798)
#define TV_AVTunerStatus	(TVT_Data+799)

/* ------------------------- */
/*  SATTuner Specific Tags - */
/* ------------------------- */

#define TV_SATTunerFrequency	(TVT_Data+800)
#define TV_SATTunerFrequencyMin	(TVT_Data+801)
#define TV_SATTunerFrequencyMax	(TVT_Data+802)
#define TV_SATTunerMode		(TVT_Data+803)
#define TV_SATTunerScan		(TVT_Data+804)

#define TV_SATTunerSetup	(TVT_Data+997)
#define TV_SATTunerSupport	(TVT_Data+998)
#define TV_SATTunerStatus	(TVT_Data+999)

/* ----------------------- */
/*  Remote Specific Tags - */
/* ----------------------- */

#define TV_RemoteKey		(TVT_Data+1000)

#define TV_RemoteSetup		(TVT_Data+1197)
#define TV_RemoteSupport	(TVT_Data+1198)
#define TV_RemoteStatus		(TVT_Data+1199)

/* ----------------------- */
/*  Volume Specific Tags - */
/* ----------------------- */

#define TV_Volume		(TVT_Data+1201)	/* LONG (0x0000vvvv,0xvvvv0000) (left,right) */
#define TV_VolumeMute		(TVT_Data+1204)	/* BOOL (0x00000000,0xffffffff) */

#define TV_VolumeSetup		(TVT_Data+1397)
#define TV_VolumeSupport	(TVT_Data+1398)
#define TV_VolumeStatus		(TVT_Data+1399)

/* -------------------------- Insert data Tags here!! -------------------------- */
/* --- These aren't defined! Contact AmithlonTV team if you need any extension - */
/* ----------------------------------------------------------------------------- */


/* TV_SATTunerPolarity      = TVT_Data+22 */
/* TV_SATTunerSymbolRate    = TVT_Data+23 */
/* TV_SATTunerACBW          = TVT_Data+24 */
/* TV_SATTunerAudioPID      = TVT_Data+25 */
/* TV_SATTunerVideoPID      = TVT_Data+26 */
/* TV_SATTunerTextPID       = TVT_Data+27 */
/* TV_SATTunerDataPID       = TVT_Data+28 */
/* TV_SATTunerDiseqc        = TVT_Data+29 */

/* ----------------------------------- */
/* ----------------------------------- */
/*  Memory type hardware setup tags! - */
/* ----------------------------------- */
/* ----------------------------------- */

/* ----------------------- */
/*  Driver Specific Tags - */
/* ----------------------- */

/* TV_                      = TVT_Memory+000 */
#define TV_DriverGPIOMask	(TVT_Memory+195)
#define TV_DriverGPIOOE		(TVT_Memory+196)
#define TV_DriverGPIOData	(TVT_Memory+197)

/* ---------------------- */
/*  Audio Specific Tags - */
/* ---------------------- */

#define TV_AudioInputTypes	(TVT_Memory+200)
#define TV_AudioInputData	(TVT_Memory+201)
#define TV_AudioInputModes	(TVT_Memory+202)
#define TV_AudioInputNorms	(TVT_Memory+203)
#define TV_AudioGPIOMask	(TVT_Memory+395)
#define TV_AudioGPIOOE		(TVT_Memory+396)
#define TV_AudioGPIOData	(TVT_Memory+397)

/* ---------------------- */
/*  Video Specific Tags - */
/* ---------------------- */

#define TV_VideoInputTypes	(TVT_Memory+400)
#define TV_VideoInputData	(TVT_Memory+401)
#define TV_VideoInputNorms	(TVT_Memory+402)
#define TV_VideoRGBFormats	(TVT_Memory+403)
#define TV_VideoGPIOMask	(TVT_Memory+595)
#define TV_VideoGPIOOE		(TVT_Memory+596)
#define TV_VideoGPIOData	(TVT_Memory+597)

/* ------------------------ */
/*  AVTuner Specific Tags - */
/* ------------------------ */

#define TV_AVTunerInputNorms	(TVT_Memory+600)
#define TV_AVTunerInputData	(TVT_Memory+601)
#define TV_AVTunerModes		(TVT_Memory+602)
#define TV_AVTunerGPIOMask	(TVT_Memory+795)
#define TV_AVTunerGPIOOE	(TVT_Memory+796)
#define TV_AVTunerGPIOData	(TVT_Memory+797)

/* ------------------------- */
/*  SATTuner Specific Tags - */
/* ------------------------- */

/* TV_                      = TVT_Memory+800 */
#define TV_SATTunerGPIOMask	(TVT_Memory+995)
#define TV_SATTunerGPIOOE	(TVT_Memory+996)
#define TV_SATTunerGPIOData	(TVT_Memory+997)

/* ----------------------- */
/*  Remote Specific Tags - */
/* ----------------------- */

/* TV_                      = TVT_Memory+1000 */
#define TV_RemoteGPIOMask	(TVT_Memory+1195)
#define TV_RemoteGPIOOE		(TVT_Memory+1196)
#define TV_RemoteGPIOData	(TVT_Memory+1197)

/* ----------------------- */
/*  Volume Specific Tags - */
/* ----------------------- */

/* TV_                      = TVT_Memory+1200 */
#define TV_VolumeGPIOMask	(TVT_Memory+1395)
#define TV_VolumeGPIOOE		(TVT_Memory+1396)
#define TV_VolumeGPIOData	(TVT_Memory+1397)

/* -------------------------- Insert Memory Tags here!! ----------------------- */

/* ---------------------------------------------------------------------------- */

/* ------------------------------ */
/*  Flags for TV_AVTunerSupport - */
/* ------------------------------ */

#define AVTunerSupportB_Search	(0)

#define AVTunerSupportF_Search	(1<<0)


/* ---------------------------- */
/*  Flags for TV_VideoSupport - */
/* ---------------------------- */

#define VideoSupportB_MultiBuffering	(0)
#define VideoSupportB_Interlace	(1)

#define VideoSupportF_MultiBuffering	(1<<0)
#define VideoSupportF_Interlace	(1<<1)

/* ------------------------------------------------------ */
/*  VideoNorms used with TV_VideoNorm and TV_VideoNorms - */
/* ------------------------------------------------------ */
#define VideoNormGroup_Unknown	(0x00010000)
#define VideoNormGroup_PAL	(0x00020000)
#define VideoNormGroup_NTSC	(0x00030000)
#define VideoNormGroup_SECAM	(0x00040000)

#define VideoNormGroup_Mask	(0xffff0000)

#define VideoNorm_Auto		(0+VideoNormGroup_Unknown)

#define VideoNorm_PAL		(0+VideoNormGroup_PAL)
#define VideoNorm_PAL_M		(1+VideoNormGroup_PAL)
#define VideoNorm_PAL_N		(2+VideoNormGroup_PAL)

#define VideoNorm_NTSC		(0+VideoNormGroup_NTSC)
#define VideoNorm_NTSC_J	(1+VideoNormGroup_NTSC)

#define VideoNorm_SECAM		(0+VideoNormGroup_SECAM)
#define VideoNorm_Unknown	(0xffffffff)

#define VideoNorm_PAL_B		(VideoNorm_PAL)
#define VideoNorm_PAL_D		(VideoNorm_PAL)
#define VideoNorm_PAL_G		(VideoNorm_PAL)
#define VideoNorm_PAL_H		(VideoNorm_PAL)
#define VideoNorm_PAL_I		(VideoNorm_PAL)

#define VideoNorm_NTSC_M	(VideoNorm_NTSC)

/* ---------------------------------------------------------------- */
/*  VideoTypes used with TV_VideoInputType and TV_VideoInputTypes - */
/* ---------------------------------------------------------------- */
#define VideoType_VHS1		(001)
#define VideoType_VHS2		(002)
#define VideoType_VHS3		(003)
#define VideoType_VHS4		(004)
#define VideoType_VHS5		(005)
#define VideoType_VHS6		(006)
#define VideoType_VHS7		(007)
#define VideoType_VHS8		(008)

#define VideoType_Tuner1	(101)
#define VideoType_Tuner2	(102)
#define VideoType_Tuner3	(103)
#define VideoType_Tuner4	(104)
#define VideoType_Tuner5	(105)
#define VideoType_Tuner6	(106)
#define VideoType_Tuner7	(107)
#define VideoType_Tuner8	(108)

#define VideoType_SVHS1		(201)
#define VideoType_SVHS2		(202)
#define VideoType_SVHS3		(203)
#define VideoType_SVHS4		(204)
#define VideoType_SVHS5		(205)
#define VideoType_SVHS6		(206)
#define VideoType_SVHS7		(207)
#define VideoType_SVHS8		(208)

#define VideoType_Unknown	(0xffffffff)


/* ------------------------------------------------------------ */
/*  AVTunerModes used with TV_AVTunerMode and TV_AVTunerModes - */
/* ------------------------------------------------------------ */
#define AVTunerMode_TV		(1)
#define AVTunerMode_Radio	(2)
#define AVTunerMode_Unknown	(0xffffffff)


/* ---------------------------------------------------------------- */
/*  AudioTypes used with TV_AudioInputType and TV_AudioInputTypes - */
/* ---------------------------------------------------------------- */
#define AudioType_VHS1		(001)
#define AudioType_VHS2		(002)
#define AudioType_VHS3		(003)
#define AudioType_VHS4		(004)
#define AudioType_VHS5		(005)
#define AudioType_VHS6		(006)
#define AudioType_VHS7		(007)
#define AudioType_VHS8		(008)

#define AudioType_Tuner1	(101)
#define AudioType_Tuner2	(102)
#define AudioType_Tuner3	(103)
#define AudioType_Tuner4	(104)
#define AudioType_Tuner5	(105)
#define AudioType_Tuner6	(106)
#define AudioType_Tuner7	(107)
#define AudioType_Tuner8	(108)

#define AudioType_SVHS1		(201)
#define AudioType_SVHS2		(202)
#define AudioType_SVHS3		(203)
#define AudioType_SVHS4		(204)
#define AudioType_SVHS5		(205)
#define AudioType_SVHS6		(206)
#define AudioType_SVHS7		(207)
#define AudioType_SVHS8		(208)

#define AudioType_Radio1	(301)
#define AudioType_Radio2	(302)
#define AudioType_Radio3	(303)
#define AudioType_Radio4	(304)
#define AudioType_Radio5	(305)
#define AudioType_Radio6	(306)
#define AudioType_Radio7	(307)
#define AudioType_Radio8	(308)

#define AudioType_Extern1	(401)
#define AudioType_Extern2	(402)
#define AudioType_Extern3	(403)
#define AudioType_Extern4	(404)
#define AudioType_Extern5	(405)
#define AudioType_Extern6	(406)
#define AudioType_Extern7	(407)
#define AudioType_Extern8	(408)

#define AudioType_Unknown	(0xffffffff)


/* ---------------------------------------------------------------- */
/*  AudioModes used with TV_AudioInputMode and TV_AudioInputModes - */
/* ---------------------------------------------------------------- */
#define AudioMode_Mute		(1)
#define AudioMode_Mono		(2)
#define AudioMode_Stereo	(3)
#define AudioMode_Channel1	(4)
#define AudioMode_Channel2	(5)
#define AudioMode_Unknown	(0xffffffff)


/* ---------------------------------------------------------- */
/*  AudioNorms used with AudioInputNorm and AudioInputNorms - */
/* ---------------------------------------------------------- */
#define AudioNorm_Auto		(1)
#define AudioNorm_Dual_FM_M	(2)
#define AudioNorm_Dual_FM_BG	(3)
#define AudioNorm_Nicam_FM_I	(4)
#define AudioNorm_Nicam_AM_L	(5)
#define AudioNorm_Unknown	(0xffffffff)


/* --------------------------------- */
/*  Pre defined TV_Priority values - */
/* --------------------------------- */
#define Priority_TV		(0)
#define Priority_WebCam		(10)
#define Priority_VCR		(80)


/* ------------------------------------------------------------ */
/*  #?_Status values if return code is "SubLib_Result_Failed" - */
/* ------------------------------------------------------------ */
#define Status_NoProblem	(0)
#define Status_NotEnoughMemory	(1)	/* Memory Trouble. */
#define Status_HardwareDamage	(2)	/* Hardware isn't operating correct. */
#define Status_HardwareUnknown	(3)	/* Wrong driver used. */
#define Status_I2CNotFound	(4)	/* I2C Not Found */
#define Status_I2CUnableToOpen	(5)	/* I2C Port  */
#define Status_I2CWriteError	(6)	/* I2C write failed */
#define Status_I2CReadError	(7)	/* I2C read failed */
#define Status_GPIONotFound	(8)	/* I2C Port  */
#define Status_GPIOUnableToOpen	(9)	/* GPIO Port  */
#define Status_PCINotFound	(10)	/* I2C Port  */
#define Status_PCIUnableToOpen	(11)	/* I2C Port  */
#define Status_BaseMemoryNotFound	(12)	/* BaseMemory not found */
#define Status_TimerUnableToOpen	(13)	/* Timer.device failed */

/* ---------------------------------------------- */
/*  These are the TV_#?TunerScan control values - */
/* ---------------------------------------------- */
#define Tuner_Search_Stop	(0)	/* Set by tuner sub library: No channel */
#define Tuner_Search_Found	(1)	/* Set by tuner sub library: Channel Found */
#define Tuner_Search_Up		(2)	/* Search one step up */
#define Tuner_Search_Down	(3)	/* Search one step down */
#define Tuner_Search_Fine	(4)	/* Perform AFC on current frequency  */
#define Tuner_Search_NotAvailable	(5)	/* Tuner does not support search mode */


/* ---------------------------------------- */
/*  RGB modes supported by tvcard.library - */
/* ---------------------------------------- */
#define TVRGBF_Planar		(0x00050000)
#define TVRGBF_TrueAlpha	(0x00040000)
#define TVRGBF_TrueColor	(0x00030000)
#define TVRGBF_HiColor		(0x00020000)
#define TVRGBF_Chunky8Bit	(0x00010000)

#define TVRGBF_TypeMask		(0xffff0000)

#define TVRGBF_None		(0)

#define TVRGBF_R8G8B8		(1+TVRGBF_TrueColor)
#define TVRGBF_B8G8R8		(2+TVRGBF_TrueColor)

#define TVRGBF_A8R8G8B8		(1+TVRGBF_TrueAlpha)
#define TVRGBF_A8B8G8R8		(2+TVRGBF_TrueAlpha)
#define TVRGBF_R8G8B8A8		(3+TVRGBF_TrueAlpha)
#define TVRGBF_B8G8R8A8		(4+TVRGBF_TrueAlpha)

#define TVRGBF_R5G6B5		(1+TVRGBF_HiColor)
#define TVRGBF_R5G6B5PC		(2+TVRGBF_HiColor)
#define TVRGBF_R5G5B5		(3+TVRGBF_HiColor)
#define TVRGBF_R5G5B5PC		(4+TVRGBF_HiColor)

#define TVRGBF_B5G6R5		(10+TVRGBF_HiColor)
#define TVRGBF_B5G6R5PC		(11+TVRGBF_HiColor)
#define TVRGBF_B5G5R5		(12+TVRGBF_HiColor)
#define TVRGBF_B5G5R5PC		(13+TVRGBF_HiColor)

#define TVRGBF_Y4U2V2		(20+TVRGBF_HiColor)
#define TVRGBF_Y4U1V1		(21+TVRGBF_HiColor)

#define TVRGBF_Dithered		(1+TVRGBF_Chunky8Bit)
#define TVRGBF_Gray		(2+TVRGBF_Chunky8Bit)



