;--------------------------
;--------------------------
; Some global tag defines -
;--------------------------
;--------------------------

TVT_Data        = $80001000         ;Just a tag offset like TAG_USER
TVT_Memory      = $C0001000         ;Just a tag offset like TAG_USER

TV_VendorID          = $90001018
TV_DeviceID          = $90001019
TV_SubSystemID       = $9000101A
TV_SubSystemVendorID = $9000101B
TV_RevisionID        = $9000101C
TV_ClassRevision     = $9000101D
TV_InternalID        = $9000101E
TV_PCIHandle         = $9000101F
TV_BaseMemory        = $90001020
TV_IRQNumber         = $90001021
TV_Priority          = $90001022
TV_Number            = $90001023
TV_Task              = $90001024
TV_TaskSignalMask    = $90001025
TV_UpdateCard        = $90001026

TV_CardName          = $D0001019
TV_VendorName        = $D000101A
TV_SubSystemVendorName = $D000101B


;---------------------------------
;---------------------------------
; Data type hardware setup tags! -
;---------------------------------
;---------------------------------

;-----------------------
; Driver Specific Tags -
;-----------------------

;TV_                      = TVT_Data+000
TV_DriverSetup            = TVT_Data+197
TV_DriverSupport          = TVT_Data+198
TV_DriverStatus           = TVT_Data+199

;----------------------
; Audio Specific Tags -
;----------------------

TV_AudioInputType         = TVT_Data+200
TV_AudioInputMode         = TVT_Data+201
TV_AudioInputNorm         = TVT_Data+202

TV_AudioSetup             = TVT_Data+397
TV_AudioSupport           = TVT_Data+398
TV_AudioStatus            = TVT_Data+399

;----------------------
; Video Specific Tags -
;----------------------

TV_VideoInputType         = TVT_Data+400
TV_VideoTargetWidth       = TVT_Data+401
TV_VideoTargetHeight      = TVT_Data+402
TV_VideoTargetArray       = TVT_Data+403
TV_VideoTargetReserved    = TVT_Data+404
TV_VideoTargetBytesPerRow = TVT_Data+405
TV_VideoTargetRGBFormat   = TVT_Data+406
TV_VideoWidthMax          = TVT_Data+407 ;Maximal width of the current signal (may be scaled)
TV_VideoHeightMax         = TVT_Data+408 ;Maximal height of the current signal (may be scaled)
TV_VideoWidthMin          = TVT_Data+409 ;Minimal width of the current signal (may be scaled)
TV_VideoHeightMin         = TVT_Data+410 ;Minimal height of the current signal (may be scaled)
TV_VideoWidthFull         = TVT_Data+411 ;Full width of the current signal (no interpolation/no scaling)
TV_VideoHeightFull        = TVT_Data+412 ;Full height of the current signal (no interpolation/no scaling)
TV_VideoWidthLimit        = TVT_Data+413 ;Maximal possible width
TV_VideoHeightLimit       = TVT_Data+414 ;Maximal possible height

TV_VideoBrightness        = TVT_Data+415 ;LONG (not ULONG !!!)
TV_VideoContrast          = TVT_Data+416 ;LONG (not ULONG !!!)
TV_VideoColor             = TVT_Data+417 ;LONG (not ULONG !!!)

TV_VideoInputNorm         = TVT_Data+418

TV_VideoSetup             = TVT_Data+597
TV_VideoSupport           = TVT_Data+598
TV_VideoStatus            = TVT_Data+599

;------------------------
; AVTuner Specific Tags -
;------------------------

TV_AVTunerFrequency       = TVT_Data+600
TV_AVTunerFrequencyMin    = TVT_Data+601
TV_AVTunerFrequencyMax    = TVT_Data+602
TV_AVTunerMode            = TVT_Data+603
TV_AVTunerScan            = TVT_Data+604

TV_AVTunerSetup           = TVT_Data+797
TV_AVTunerSupport         = TVT_Data+798
TV_AVTunerStatus          = TVT_Data+799

;-------------------------
; SATTuner Specific Tags -
;-------------------------

TV_SATTunerFrequency      = TVT_Data+800
TV_SATTunerFrequencyMin   = TVT_Data+801
TV_SATTunerFrequencyMax   = TVT_Data+802
TV_SATTunerMode           = TVT_Data+803
TV_SATTunerScan           = TVT_Data+804

TV_SATTunerSetup          = TVT_Data+997
TV_SATTunerSupport        = TVT_Data+998
TV_SATTunerStatus         = TVT_Data+999

;-----------------------
; Remote Specific Tags -
;-----------------------

TV_RemoteKey              = TVT_Data+1000

TV_RemoteSetup            = TVT_Data+1197
TV_RemoteSupport          = TVT_Data+1198
TV_RemoteStatus           = TVT_Data+1199

;-----------------------
; Volume Specific Tags -
;-----------------------

TV_Volume                 = TVT_Data+1201 ;LONG (0x0000vvvv,0xvvvv0000) (left,right)
TV_VolumeMute             = TVT_Data+1204 ;BOOL (0x00000000,0xffffffff)

TV_VolumeSetup            = TVT_Data+1397
TV_VolumeSupport          = TVT_Data+1398
TV_VolumeStatus           = TVT_Data+1399

;-------------------------- Insert data Tags here!! --------------------------
;--- These aren't defined! Contact AmithlonTV team if you need any extension -
;-----------------------------------------------------------------------------


;TV_SATTunerPolarity      = TVT_Data+22
;TV_SATTunerSymbolRate    = TVT_Data+23
;TV_SATTunerACBW          = TVT_Data+24
;TV_SATTunerAudioPID      = TVT_Data+25
;TV_SATTunerVideoPID      = TVT_Data+26
;TV_SATTunerTextPID       = TVT_Data+27
;TV_SATTunerDataPID       = TVT_Data+28
;TV_SATTunerDiseqc        = TVT_Data+29

;-----------------------------------
;-----------------------------------
; Memory type hardware setup tags! -
;-----------------------------------
;-----------------------------------

;-----------------------
; Driver Specific Tags -
;-----------------------

;TV_                      = TVT_Memory+000
TV_DriverGPIOMask         = TVT_Memory+195
TV_DriverGPIOOE           = TVT_Memory+196
TV_DriverGPIOData         = TVT_Memory+197

;----------------------
; Audio Specific Tags -
;----------------------

TV_AudioInputTypes        = TVT_Memory+200
TV_AudioInputData         = TVT_Memory+201
TV_AudioInputModes        = TVT_Memory+202
TV_AudioInputNorms        = TVT_Memory+203
TV_AudioGPIOMask          = TVT_Memory+395
TV_AudioGPIOOE            = TVT_Memory+396
TV_AudioGPIOData          = TVT_Memory+397

;----------------------
; Video Specific Tags -
;----------------------

TV_VideoInputTypes        = TVT_Memory+400
TV_VideoInputData         = TVT_Memory+401
TV_VideoInputNorms        = TVT_Memory+402
TV_VideoRGBFormats        = TVT_Memory+403
TV_VideoGPIOMask          = TVT_Memory+595
TV_VideoGPIOOE            = TVT_Memory+596
TV_VideoGPIOData          = TVT_Memory+597

;------------------------
; AVTuner Specific Tags -
;------------------------

TV_AVTunerInputNorms      = TVT_Memory+600
TV_AVTunerInputData       = TVT_Memory+601
TV_AVTunerModes           = TVT_Memory+602
TV_AVTunerGPIOMask        = TVT_Memory+795
TV_AVTunerGPIOOE          = TVT_Memory+796
TV_AVTunerGPIOData        = TVT_Memory+797

;-------------------------
; SATTuner Specific Tags -
;-------------------------

;TV_                      = TVT_Memory+800
TV_SATTunerGPIOMask       = TVT_Memory+995
TV_SATTunerGPIOOE         = TVT_Memory+996
TV_SATTunerGPIOData       = TVT_Memory+997

;-----------------------
; Remote Specific Tags -
;-----------------------

;TV_                      = TVT_Memory+1000
TV_RemoteGPIOMask         = TVT_Memory+1195
TV_RemoteGPIOOE           = TVT_Memory+1196
TV_RemoteGPIOData         = TVT_Memory+1197

;-----------------------
; Volume Specific Tags -
;-----------------------

;TV_                      = TVT_Memory+1200
TV_VolumeGPIOMask         = TVT_Memory+1395
TV_VolumeGPIOOE           = TVT_Memory+1396
TV_VolumeGPIOData         = TVT_Memory+1397

;-------------------------- Insert Memory Tags here!! -----------------------

;----------------------------------------------------------------------------

;------------------------------
; Flags for TV_AVTunerSupport -
;------------------------------

AVTunerSupportB_Search       = 0

AVTunerSupportF_Search       = 1<<0


;----------------------------
; Flags for TV_VideoSupport -
;----------------------------

VideoSupportB_MultiBuffering  = 0
VideoSupportB_Interlace       = 1

VideoSupportF_MultiBuffering  = 1<<0
VideoSupportF_Interlace       = 1<<1

;------------------------------------------------------
; VideoNorms used with TV_VideoNorm and TV_VideoNorms -
;------------------------------------------------------
VideoNormGroup_Unknown	= $00010000
VideoNormGroup_PAL	= $00020000
VideoNormGroup_NTSC	= $00030000
VideoNormGroup_SECAM	= $00040000

VideoNormGroup_Mask     = $ffff0000

VideoNorm_Auto          = 0+VideoNormGroup_Unknown

VideoNorm_PAL           = 0+VideoNormGroup_PAL
VideoNorm_PAL_M         = 1+VideoNormGroup_PAL
VideoNorm_PAL_N         = 2+VideoNormGroup_PAL

VideoNorm_NTSC          = 0+VideoNormGroup_NTSC
VideoNorm_NTSC_J        = 1+VideoNormGroup_NTSC

VideoNorm_SECAM         = 0+VideoNormGroup_SECAM
VideoNorm_Unknown       = $ffffffff

VideoNorm_PAL_B         = VideoNorm_PAL
VideoNorm_PAL_D         = VideoNorm_PAL
VideoNorm_PAL_G         = VideoNorm_PAL
VideoNorm_PAL_H         = VideoNorm_PAL
VideoNorm_PAL_I         = VideoNorm_PAL

VideoNorm_NTSC_M	= VideoNorm_NTSC

;----------------------------------------------------------------
; VideoTypes used with TV_VideoInputType and TV_VideoInputTypes -
;----------------------------------------------------------------
VideoType_VHS1          = 001
VideoType_VHS2          = 002
VideoType_VHS3          = 003
VideoType_VHS4          = 004
VideoType_VHS5          = 005
VideoType_VHS6          = 006
VideoType_VHS7          = 007
VideoType_VHS8          = 008

VideoType_Tuner1        = 101
VideoType_Tuner2        = 102
VideoType_Tuner3        = 103
VideoType_Tuner4        = 104
VideoType_Tuner5        = 105
VideoType_Tuner6        = 106
VideoType_Tuner7        = 107
VideoType_Tuner8        = 108

VideoType_SVHS1         = 201
VideoType_SVHS2         = 202
VideoType_SVHS3         = 203
VideoType_SVHS4         = 204
VideoType_SVHS5         = 205
VideoType_SVHS6         = 206
VideoType_SVHS7         = 207
VideoType_SVHS8         = 208

VideoType_Unknown       = $ffffffff


;------------------------------------------------------------
; AVTunerModes used with TV_AVTunerMode and TV_AVTunerModes -
;------------------------------------------------------------
AVTunerMode_TV          = 1
AVTunerMode_Radio       = 2
AVTunerMode_Unknown     = $ffffffff


;----------------------------------------------------------------
; AudioTypes used with TV_AudioInputType and TV_AudioInputTypes -
;----------------------------------------------------------------
AudioType_VHS1          = 001
AudioType_VHS2          = 002
AudioType_VHS3          = 003
AudioType_VHS4          = 004
AudioType_VHS5          = 005
AudioType_VHS6          = 006
AudioType_VHS7          = 007
AudioType_VHS8          = 008

AudioType_Tuner1        = 101
AudioType_Tuner2        = 102
AudioType_Tuner3        = 103
AudioType_Tuner4        = 104
AudioType_Tuner5        = 105
AudioType_Tuner6        = 106
AudioType_Tuner7        = 107
AudioType_Tuner8        = 108

AudioType_SVHS1         = 201
AudioType_SVHS2         = 202
AudioType_SVHS3         = 203
AudioType_SVHS4         = 204
AudioType_SVHS5         = 205
AudioType_SVHS6         = 206
AudioType_SVHS7         = 207
AudioType_SVHS8         = 208

AudioType_Radio1        = 301
AudioType_Radio2        = 302
AudioType_Radio3        = 303
AudioType_Radio4        = 304
AudioType_Radio5        = 305
AudioType_Radio6        = 306
AudioType_Radio7        = 307
AudioType_Radio8        = 308

AudioType_Extern1       = 401
AudioType_Extern2       = 402
AudioType_Extern3       = 403
AudioType_Extern4       = 404
AudioType_Extern5       = 405
AudioType_Extern6       = 406
AudioType_Extern7       = 407
AudioType_Extern8       = 408

AudioType_Unknown       = $ffffffff


;----------------------------------------------------------------
; AudioModes used with TV_AudioInputMode and TV_AudioInputModes -
;----------------------------------------------------------------
AudioMode_Mute          = 1
AudioMode_Mono          = 2
AudioMode_Stereo        = 3
AudioMode_Channel1      = 4
AudioMode_Channel2      = 5
AudioMode_Unknown       = $ffffffff


;----------------------------------------------------------
; AudioNorms used with AudioInputNorm and AudioInputNorms -
;----------------------------------------------------------
AudioNorm_Auto          = 1
AudioNorm_Dual_FM_M     = 2
AudioNorm_Dual_FM_BG    = 3
AudioNorm_Nicam_FM_I    = 4
AudioNorm_Nicam_AM_L    = 5
AudioNorm_Unknown       = $ffffffff


;---------------------------------
; Pre defined TV_Priority values -
;---------------------------------
Priority_TV          = 0
Priority_WebCam      = 10
Priority_VCR         = 80


;------------------------------------------------------------
; #?_Status values if return code is "SubLib_Result_Failed" -
;------------------------------------------------------------
Status_NoProblem                = 0
Status_NotEnoughMemory          = 1  ;Memory Trouble.
Status_HardwareDamage           = 2  ;Hardware isn't operating correct.
Status_HardwareUnknown          = 3  ;Wrong driver used.
Status_I2CNotFound              = 4  ;I2C Not Found
Status_I2CUnableToOpen          = 5  ;I2C Port 
Status_I2CWriteError            = 6  ;I2C write failed
Status_I2CReadError             = 7  ;I2C read failed
Status_GPIONotFound             = 8  ;I2C Port 
Status_GPIOUnableToOpen         = 9  ;GPIO Port 
Status_PCINotFound              = 10 ;I2C Port 
Status_PCIUnableToOpen          = 11 ;I2C Port 
Status_BaseMemoryNotFound       = 12 ;BaseMemory not found
Status_TimerUnableToOpen        = 13 ;Timer.device failed

;----------------------------------------------
; These are the TV_#?TunerScan control values -
;----------------------------------------------
Tuner_Search_Stop         = 0 ;Set by tuner sub library: No channel
Tuner_Search_Found        = 1 ;Set by tuner sub library: Channel Found
Tuner_Search_Up           = 2 ;Search one step up
Tuner_Search_Down         = 3 ;Search one step down
Tuner_Search_Fine         = 4 ;Perform AFC on current frequency 
Tuner_Search_NotAvailable = 5 ;Tuner does not support search mode


;----------------------------------------
; RGB modes supported by tvcard.library -
;----------------------------------------
TVRGBF_Planar          = $00050000
TVRGBF_TrueAlpha       = $00040000
TVRGBF_TrueColor       = $00030000
TVRGBF_HiColor         = $00020000
TVRGBF_Chunky8Bit      = $00010000

TVRGBF_TypeMask        = $ffff0000

TVRGBF_None            = 0

TVRGBF_R8G8B8          = 1+TVRGBF_TrueColor
TVRGBF_B8G8R8          = 2+TVRGBF_TrueColor

TVRGBF_A8R8G8B8        = 1+TVRGBF_TrueAlpha
TVRGBF_A8B8G8R8        = 2+TVRGBF_TrueAlpha
TVRGBF_R8G8B8A8        = 3+TVRGBF_TrueAlpha
TVRGBF_B8G8R8A8        = 4+TVRGBF_TrueAlpha

TVRGBF_R5G6B5          = 1+TVRGBF_HiColor
TVRGBF_R5G6B5PC        = 2+TVRGBF_HiColor
TVRGBF_R5G5B5          = 3+TVRGBF_HiColor
TVRGBF_R5G5B5PC        = 4+TVRGBF_HiColor

TVRGBF_B5G6R5          = 10+TVRGBF_HiColor
TVRGBF_B5G6R5PC        = 11+TVRGBF_HiColor
TVRGBF_B5G5R5          = 12+TVRGBF_HiColor
TVRGBF_B5G5R5PC        = 13+TVRGBF_HiColor

TVRGBF_Y4U2V2          = 20+TVRGBF_HiColor
TVRGBF_Y4U1V1          = 21+TVRGBF_HiColor

TVRGBF_Dithered        = 1+TVRGBF_Chunky8Bit
TVRGBF_Gray            = 2+TVRGBF_Chunky8Bit



